Index: /pykota/branches/1.26_fixes/pykota/storages/sql.py
===================================================================
--- /pykota/branches/1.26_fixes/pykota/storages/sql.py (revision 3393)
+++ /pykota/branches/1.26_fixes/pykota/storages/sql.py (revision 3522)
@@ -14,5 +14,5 @@
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
-# 
+#
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
@@ -28,4 +28,6 @@
                            StorageJob, StorageLastJob, StorageUserPQuota, \
                            StorageGroupPQuota, StorageBillingCode
+
+MAXINNAMES = 500 # Maximum number of non-patterns names to use in a single IN statement
 
 class SQLStorage :
@@ -42,5 +44,5 @@
         user.Exists = True
         return user
-        
+
     def storageGroupFromRecord(self, groupname, record) :
         """Returns a StorageGroup instance from a database record."""
@@ -53,5 +55,5 @@
         group.Exists = True
         return group
-        
+
     def storagePrinterFromRecord(self, printername, record) :
         """Returns a StoragePrinter instance from a database record."""
@@ -69,6 +71,6 @@
         printer.Exists = True
         return printer
-        
-    def setJobAttributesFromRecord(self, job, record) :    
+
+    def setJobAttributesFromRecord(self, job, record) :
         """Sets the attributes of a job from a database record."""
         job.ident = record.get("id")
@@ -78,8 +80,8 @@
         job.JobPrice = record.get("jobprice")
         job.JobAction = record.get("action")
-        job.JobFileName = self.databaseToUserCharset(record.get("filename") or "") 
-        job.JobTitle = self.databaseToUserCharset(record.get("title") or "") 
+        job.JobFileName = self.databaseToUserCharset(record.get("filename") or "")
+        job.JobTitle = self.databaseToUserCharset(record.get("title") or "")
         job.JobCopies = record.get("copies")
-        job.JobOptions = self.databaseToUserCharset(record.get("options") or "") 
+        job.JobOptions = self.databaseToUserCharset(record.get("options") or "")
         job.JobDate = record.get("jobdate")
         job.JobHostName = record.get("hostname")
@@ -95,5 +97,5 @@
             (job.JobTitle, job.JobFileName, job.JobOptions) = (_("Hidden because of privacy concerns"),) * 3
         job.Exists = True
-        
+
     def storageJobFromRecord(self, record) :
         """Returns a StorageJob instance from a database record."""
@@ -101,5 +103,5 @@
         self.setJobAttributesFromRecord(job, record)
         return job
-        
+
     def storageLastJobFromRecord(self, printer, record) :
         """Returns a StorageLastJob instance from a database record."""
@@ -107,5 +109,5 @@
         self.setJobAttributesFromRecord(lastjob, record)
         return lastjob
-        
+
     def storageUserPQuotaFromRecord(self, user, printer, record) :
         """Returns a StorageUserPQuota instance from a database record."""
@@ -120,5 +122,5 @@
         userpquota.Exists = True
         return userpquota
-        
+
     def storageGroupPQuotaFromRecord(self, group, printer, record) :
         """Returns a StorageGroupPQuota instance from a database record."""
@@ -135,5 +137,5 @@
         grouppquota.Exists = True
         return grouppquota
-        
+
     def storageBillingCodeFromRecord(self, billingcode, record) :
         """Returns a StorageBillingCode instance from a database record."""
@@ -145,6 +147,6 @@
         code.Exists = True
         return code
-        
-    def createFilter(self, only) :    
+
+    def createFilter(self, only) :
         """Returns the appropriate SQL filter."""
         if only :
@@ -152,21 +154,21 @@
             for (k, v) in only.items() :
                 expressions.append("%s=%s" % (k, self.doQuote(self.userCharsetToDatabase(v))))
-            return " AND ".join(expressions)     
-        return ""        
-        
-    def createOrderBy(self, default, ordering) :    
+            return " AND ".join(expressions)
+        return ""
+
+    def createOrderBy(self, default, ordering) :
         """Creates a suitable ORDER BY statement based on a list of fieldnames prefixed with '+' (ASC) or '-' (DESC)."""
         statements = []
         if not ordering :
             ordering = default
-        for field in ordering :    
-            if field.startswith("-") :    
+        for field in ordering :
+            if field.startswith("-") :
                 statements.append("%s DESC" % field[1:])
             elif field.startswith("+") :
                 statements.append("%s ASC" % field[1:])
-            else :    
+            else :
                 statements.append("%s ASC" % field)
-        return ", ".join(statements)    
-        
+        return ", ".join(statements)
+
     def extractPrinters(self, extractonly={}, ordering=[]) :
         """Extracts all printer records."""
@@ -177,5 +179,5 @@
         result = self.doRawSearch("SELECT * FROM printers %(thefilter)s ORDER BY %(orderby)s" % locals())
         return self.prepareRawResult(result)
-        
+
     def extractUsers(self, extractonly={}, ordering=[]) :
         """Extracts all user records."""
@@ -186,5 +188,5 @@
         result = self.doRawSearch("SELECT * FROM users %(thefilter)s ORDER BY %(orderby)s" % locals())
         return self.prepareRawResult(result)
-        
+
     def extractBillingcodes(self, extractonly={}, ordering=[]) :
         """Extracts all billing codes records."""
@@ -195,5 +197,5 @@
         result = self.doRawSearch("SELECT * FROM billingcodes %(thefilter)s ORDER BY %(orderby)s" % locals())
         return self.prepareRawResult(result)
-        
+
     def extractGroups(self, extractonly={}, ordering=[]) :
         """Extracts all group records."""
@@ -204,5 +206,5 @@
         result = self.doRawSearch("SELECT groups.*,COALESCE(SUM(balance), 0) AS balance, COALESCE(SUM(lifetimepaid), 0) as lifetimepaid FROM groups LEFT OUTER JOIN users ON users.id IN (SELECT userid FROM groupsmembers WHERE groupid=groups.id) %(thefilter)s GROUP BY groups.id,groups.groupname,groups.limitby,groups.description ORDER BY %(orderby)s" % locals())
         return self.prepareRawResult(result)
-        
+
     def extractPayments(self, extractonly={}, ordering=[]) :
         """Extracts all payment records."""
@@ -212,5 +214,5 @@
             try :
                 del extractonly[limit]
-            except KeyError :    
+            except KeyError :
                 pass
         thefilter = self.createFilter(extractonly)
@@ -218,12 +220,12 @@
             thefilter = "AND %s" % thefilter
         (startdate, enddate) = self.cleanDates(startdate, enddate)
-        if startdate : 
+        if startdate :
             thefilter = "%s AND date>=%s" % (thefilter, self.doQuote(startdate))
-        if enddate : 
+        if enddate :
             thefilter = "%s AND date<=%s" % (thefilter, self.doQuote(enddate))
         orderby = self.createOrderBy(["+payments.id"], ordering)
         result = self.doRawSearch("SELECT username,payments.* FROM users,payments WHERE users.id=payments.userid %(thefilter)s ORDER BY %(orderby)s" % locals())
         return self.prepareRawResult(result)
-        
+
     def extractUpquotas(self, extractonly={}, ordering=[]) :
         """Extracts all userpquota records."""
@@ -234,5 +236,5 @@
         result = self.doRawSearch("SELECT users.username,printers.printername,userpquota.* FROM users,printers,userpquota WHERE users.id=userpquota.userid AND printers.id=userpquota.printerid %(thefilter)s ORDER BY %(orderby)s" % locals())
         return self.prepareRawResult(result)
-        
+
     def extractGpquotas(self, extractonly={}, ordering=[]) :
         """Extracts all grouppquota records."""
@@ -243,5 +245,5 @@
         result = self.doRawSearch("SELECT groups.groupname,printers.printername,grouppquota.*,coalesce(sum(pagecounter), 0) AS pagecounter,coalesce(sum(lifepagecounter), 0) AS lifepagecounter FROM groups,printers,grouppquota,userpquota WHERE groups.id=grouppquota.groupid AND printers.id=grouppquota.printerid AND userpquota.printerid=grouppquota.printerid AND userpquota.userid IN (SELECT userid FROM groupsmembers WHERE groupsmembers.groupid=grouppquota.groupid) %(thefilter)s GROUP BY grouppquota.id,grouppquota.groupid,grouppquota.printerid,grouppquota.softlimit,grouppquota.hardlimit,grouppquota.datelimit,grouppquota.maxjobsize,groups.groupname,printers.printername ORDER BY %(orderby)s" % locals())
         return self.prepareRawResult(result)
-        
+
     def extractUmembers(self, extractonly={}, ordering=[]) :
         """Extracts all user groups members."""
@@ -252,5 +254,5 @@
         result = self.doRawSearch("SELECT groups.groupname, users.username, groupsmembers.* FROM groups,users,groupsmembers WHERE users.id=groupsmembers.userid AND groups.id=groupsmembers.groupid %(thefilter)s ORDER BY %(orderby)s" % locals())
         return self.prepareRawResult(result)
-        
+
     def extractPmembers(self, extractonly={}, ordering=[]) :
         """Extracts all printer groups members."""
@@ -268,5 +270,5 @@
         result = self.doRawSearch("SELECT p1.printername as pgroupname, p2.printername as printername, printergroupsmembers.* FROM printers p1, printers p2, printergroupsmembers WHERE p1.id=printergroupsmembers.groupid AND p2.id=printergroupsmembers.printerid %(thefilter)s ORDER BY %(orderby)s" % locals())
         return self.prepareRawResult(result)
-        
+
     def extractHistory(self, extractonly={}, ordering=[]) :
         """Extracts all jobhistory records."""
@@ -276,5 +278,5 @@
             try :
                 del extractonly[limit]
-            except KeyError :    
+            except KeyError :
                 pass
         thefilter = self.createFilter(extractonly)
@@ -282,17 +284,17 @@
             thefilter = "AND %s" % thefilter
         (startdate, enddate) = self.cleanDates(startdate, enddate)
-        if startdate : 
+        if startdate :
             thefilter = "%s AND jobdate>=%s" % (thefilter, self.doQuote(startdate))
-        if enddate : 
+        if enddate :
             thefilter = "%s AND jobdate<=%s" % (thefilter, self.doQuote(enddate))
         orderby = self.createOrderBy(["+jobhistory.id"], ordering)
         result = self.doRawSearch("SELECT users.username,printers.printername,jobhistory.* FROM users,printers,jobhistory WHERE users.id=jobhistory.userid AND printers.id=jobhistory.printerid %(thefilter)s ORDER BY %(orderby)s" % locals())
         return self.prepareRawResult(result)
-            
+
     def filterNames(self, records, attribute, patterns=None) :
         """Returns a list of 'attribute' from a list of records.
-        
+
            Logs any missing attribute.
-        """   
+        """
         result = []
         for record in records :
@@ -307,33 +309,33 @@
                     if self.tool.matchString(attrval, patterns) :
                         result.append(attrval)
-                else :    
+                else :
                     result.append(attrval)
-        return result   
-                
-    def getAllBillingCodes(self, billingcode=None) :    
+        return result
+
+    def getAllBillingCodes(self, billingcode=None) :
         """Extracts all billing codes or only the billing codes matching the optional parameter."""
         result = self.doSearch("SELECT billingcode FROM billingcodes")
         if result :
             return self.filterNames(result, "billingcode", billingcode)
-        else :    
+        else :
             return []
-        
-    def getAllPrintersNames(self, printername=None) :    
+
+    def getAllPrintersNames(self, printername=None) :
         """Extracts all printer names or only the printers' names matching the optional parameter."""
         result = self.doSearch("SELECT printername FROM printers")
         if result :
             return self.filterNames(result, "printername", printername)
-        else :    
+        else :
             return []
-    
-    def getAllUsersNames(self, username=None) :    
+
+    def getAllUsersNames(self, username=None) :
         """Extracts all user names."""
         result = self.doSearch("SELECT username FROM users")
         if result :
             return self.filterNames(result, "username", username)
-        else :    
+        else :
             return []
-        
-    def getAllGroupsNames(self, groupname=None) :    
+
+    def getAllGroupsNames(self, groupname=None) :
         """Extracts all group names."""
         result = self.doSearch("SELECT groupname FROM groups")
@@ -342,5 +344,5 @@
         else :
             return []
-        
+
     def getUserNbJobsFromHistory(self, user) :
         """Returns the number of jobs the user has in history."""
@@ -349,6 +351,6 @@
             return result[0]["count"]
         return 0
-        
-    def getUserFromBackend(self, username) :    
+
+    def getUserFromBackend(self, username) :
         """Extracts user information given its name."""
         result = self.doSearch("SELECT * FROM users WHERE username=%s LIMIT 1"\
@@ -356,8 +358,8 @@
         if result :
             return self.storageUserFromRecord(username, result[0])
-        else :    
+        else :
             return StorageUser(self, username)
-       
-    def getGroupFromBackend(self, groupname) :    
+
+    def getGroupFromBackend(self, groupname) :
         """Extracts group information given its name."""
         result = self.doSearch("SELECT groups.*,COALESCE(SUM(balance), 0.0) AS balance, COALESCE(SUM(lifetimepaid), 0.0) AS lifetimepaid FROM groups LEFT OUTER JOIN users ON users.id IN (SELECT userid FROM groupsmembers WHERE groupid=groups.id) WHERE groupname=%s GROUP BY groups.id,groups.groupname,groups.limitby,groups.description LIMIT 1" \
@@ -365,8 +367,8 @@
         if result :
             return self.storageGroupFromRecord(groupname, result[0])
-        else :    
+        else :
             return StorageGroup(self, groupname)
-       
-    def getPrinterFromBackend(self, printername) :        
+
+    def getPrinterFromBackend(self, printername) :
         """Extracts printer information given its name."""
         result = self.doSearch("SELECT * FROM printers WHERE printername=%s LIMIT 1" \
@@ -374,8 +376,8 @@
         if result :
             return self.storagePrinterFromRecord(printername, result[0])
-        else :    
+        else :
             return StoragePrinter(self, printername)
-        
-    def getBillingCodeFromBackend(self, label) :        
+
+    def getBillingCodeFromBackend(self, label) :
         """Extracts a billing code information given its name."""
         result = self.doSearch("SELECT * FROM billingcodes WHERE billingcode=%s LIMIT 1" \
@@ -383,8 +385,8 @@
         if result :
             return self.storageBillingCodeFromRecord(label, result[0])
-        else :    
+        else :
             return StorageBillingCode(self, label)
-        
-    def getUserPQuotaFromBackend(self, user, printer) :        
+
+    def getUserPQuotaFromBackend(self, user, printer) :
         """Extracts a user print quota."""
         if printer.Exists and user.Exists :
@@ -394,6 +396,6 @@
                 return self.storageUserPQuotaFromRecord(user, printer, result[0])
         return StorageUserPQuota(self, user, printer)
-        
-    def getGroupPQuotaFromBackend(self, group, printer) :        
+
+    def getGroupPQuotaFromBackend(self, group, printer) :
         """Extracts a group print quota."""
         if printer.Exists and group.Exists :
@@ -403,14 +405,14 @@
                 return self.storageGroupPQuotaFromRecord(group, printer, result[0])
         return StorageGroupPQuota(self, group, printer)
-        
-    def getPrinterLastJobFromBackend(self, printer) :        
+
+    def getPrinterLastJobFromBackend(self, printer) :
         """Extracts a printer's last job information."""
         result = self.doSearch("SELECT jobhistory.id, jobid, userid, username, pagecounter, jobsize, jobprice, filename, title, copies, options, hostname, jobdate, md5sum, pages, billingcode, precomputedjobsize, precomputedjobprice FROM jobhistory, users WHERE printerid=%s AND userid=users.id ORDER BY jobdate DESC LIMIT 1" % self.doQuote(printer.ident))
         if result :
             return self.storageLastJobFromRecord(printer, result[0])
-        else :    
+        else :
             return StorageLastJob(self, printer)
-            
-    def getGroupMembersFromBackend(self, group) :        
+
+    def getGroupMembersFromBackend(self, group) :
         """Returns the group's members list."""
         groupmembers = []
@@ -422,7 +424,7 @@
                 groupmembers.append(user)
                 self.cacheEntry("USERS", user.Name, user)
-        return groupmembers        
-        
-    def getUserGroupsFromBackend(self, user) :        
+        return groupmembers
+
+    def getUserGroupsFromBackend(self, user) :
         """Returns the user's groups list."""
         groups = []
@@ -431,7 +433,7 @@
             for record in result :
                 groups.append(self.getGroup(self.databaseToUserCharset(record.get("groupname"))))
-        return groups        
-        
-    def getParentPrintersFromBackend(self, printer) :    
+        return groups
+
+    def getParentPrintersFromBackend(self, printer) :
         """Get all the printer groups this printer is a member of."""
         pgroups = []
@@ -444,5 +446,13 @@
                         pgroups.append(parentprinter)
         return pgroups
-        
+
+    def hasWildCards(self, pattern) :
+        """Returns True if the pattern contains wildcards, else False."""
+        specialchars = "*?[!" # no need to check for ] since [ would be there first
+        for specialchar in specialchars :
+            if specialchar in pattern :
+                return True
+        return False
+
     def getMatchingPrinters(self, printerpattern) :
         """Returns the list of all printers for which name matches a certain pattern."""
@@ -454,11 +464,5 @@
         if result :
             patterns = printerpattern.split(",")
-            try :
-                patdict = {}.fromkeys(patterns)
-            except AttributeError :    
-                # Python v2.2 or earlier
-                patdict = {}
-                for p in patterns :
-                    patdict[p] = None
+            patdict = {}.fromkeys(patterns)
             for record in result :
                 pname = self.databaseToUserCharset(record["printername"])
@@ -467,6 +471,6 @@
                     printers.append(printer)
                     self.cacheEntry("PRINTERS", printer.Name, printer)
-        return printers        
-        
+        return printers
+
     def getMatchingUsers(self, userpattern) :
         """Returns the list of all users for which name matches a certain pattern."""
@@ -475,22 +479,41 @@
         # but we don't because other storages semantics may be different, so every
         # storage should use fnmatch to match patterns and be storage agnostic
-        result = self.doSearch("SELECT * FROM users")
-        if result :
-            patterns = userpattern.split(",")
-            try :
-                patdict = {}.fromkeys(patterns)
-            except AttributeError :    
-                # Python v2.2 or earlier
-                patdict = {}
-                for p in patterns :
-                    patdict[p] = None
-            for record in result :
-                uname = self.databaseToUserCharset(record["username"])
-                if patdict.has_key(uname) or self.tool.matchString(uname, patterns) :
-                    user = self.storageUserFromRecord(uname, record)
-                    users.append(user)
-                    self.cacheEntry("USERS", user.Name, user)
-        return users        
-        
+        #
+        # This doesn't prevent us from being smarter, thanks to bse@chalmers.se
+        userpattern = userpattern or "*"
+        patterns = userpattern.split(",")
+        patdict = {}.fromkeys(patterns)
+        patterns = patdict.keys() # Ensures the uniqueness of each pattern, but we lose the cmd line ordering
+        # BEWARE : if a single pattern contains wild cards, we'll still use the slow route.
+        if self.hasWildCards(userpattern) :
+            # Slow route
+            result = self.doSearch("SELECT * FROM users")
+            if result :
+                for record in result :
+                    uname = self.databaseToUserCharset(record["username"])
+                    if patdict.has_key(uname) or self.tool.matchString(uname, patterns) :
+                        user = self.storageUserFromRecord(uname, record)
+                        users.append(user)
+                        self.cacheEntry("USERS", user.Name, user)
+        else :
+            # Fast route (probably not faster with a few users)
+            while patterns :
+                subset = patterns[:MAXINNAMES]
+                nbpatterns = len(subset)
+                if nbpatterns == 1 :
+                    wherestmt = "username=%s" % self.doQuote(self.userCharsetToDatabase(subset[0]))
+                else :
+                    wherestmt = "username IN (%s)" % ",".join([self.doQuote(self.userCharsetToDatabase(p)) for p in subset])
+                result = self.doSearch("SELECT * FROM users WHERE %s" % wherestmt)
+                if result :
+                    for record in result :
+                        uname = self.databaseToUserCharset(record["username"])
+                        user = self.storageUserFromRecord(uname, record)
+                        users.append(user)
+                        self.cacheEntry("USERS", user.Name, user)
+                patterns = patterns[MAXINNAMES:]
+        users.sort(key=lambda u : u.Name) # Adds some ordering, we've already lost the cmd line one anyway.
+        return users
+
     def getMatchingGroups(self, grouppattern) :
         """Returns the list of all groups for which name matches a certain pattern."""
@@ -502,11 +525,5 @@
         if result :
             patterns = grouppattern.split(",")
-            try :
-                patdict = {}.fromkeys(patterns)
-            except AttributeError :    
-                # Python v2.2 or earlier
-                patdict = {}
-                for p in patterns :
-                    patdict[p] = None
+            patdict = {}.fromkeys(patterns)
             for record in result :
                 gname = self.databaseToUserCharset(record["groupname"])
@@ -515,6 +532,6 @@
                     groups.append(group)
                     self.cacheEntry("GROUPS", group.Name, group)
-        return groups        
-        
+        return groups
+
     def getMatchingBillingCodes(self, billingcodepattern) :
         """Returns the list of all billing codes for which the label matches a certain pattern."""
@@ -523,11 +540,5 @@
         if result :
             patterns = billingcodepattern.split(",")
-            try :
-                patdict = {}.fromkeys(patterns)
-            except AttributeError :    
-                # Python v2.2 or earlier
-                patdict = {}
-                for p in patterns :
-                    patdict[p] = None
+            patdict = {}.fromkeys(patterns)
             for record in result :
                 codename = self.databaseToUserCharset(record["billingcode"])
@@ -536,7 +547,7 @@
                     codes.append(code)
                     self.cacheEntry("BILLINGCODES", code.BillingCode, code)
-        return codes        
-        
-    def getPrinterUsersAndQuotas(self, printer, names=["*"]) :        
+        return codes
+
+    def getPrinterUsersAndQuotas(self, printer, names=["*"]) :
         """Returns the list of users who uses a given printer, along with their quotas."""
         usersandquotas = []
@@ -552,6 +563,6 @@
                     self.cacheEntry("USERPQUOTAS", "%s@%s" % (user.Name, printer.Name), userpquota)
         return usersandquotas
-                
-    def getPrinterGroupsAndQuotas(self, printer, names=["*"]) :        
+
+    def getPrinterGroupsAndQuotas(self, printer, names=["*"]) :
         """Returns the list of groups which uses a given printer, along with their quotas."""
         groupsandquotas = []
@@ -565,6 +576,6 @@
                     groupsandquotas.append((group, grouppquota))
         return groupsandquotas
-        
-    def addPrinter(self, printer) :        
+
+    def addPrinter(self, printer) :
         """Adds a printer to the quota storage, returns the old value if it already exists."""
         oldentry = self.getPrinter(printer.Name)
@@ -580,5 +591,5 @@
         printer.isDirty = False
         return None # the entry created doesn't need further modification
-        
+
     def addBillingCode(self, bcode) :
         """Adds a billing code to the quota storage, returns the old value if it already exists."""
@@ -587,5 +598,5 @@
             return oldentry
         self.doModify("INSERT INTO billingcodes (billingcode, balance, pagecounter, description) VALUES (%s, %s, %s, %s)" \
-                           % (self.doQuote(self.userCharsetToDatabase(bcode.BillingCode)), 
+                           % (self.doQuote(self.userCharsetToDatabase(bcode.BillingCode)),
                               self.doQuote(bcode.Balance or 0.0), \
                               self.doQuote(bcode.PageCounter or 0), \
@@ -593,6 +604,6 @@
         bcode.isDirty = False
         return None # the entry created doesn't need further modification
-        
-    def addUser(self, user) :        
+
+    def addUser(self, user) :
         """Adds a user to the quota storage, returns the old value if it already exists."""
         oldentry = self.getUser(user.Name)
@@ -613,6 +624,6 @@
         user.isDirty = False
         return None # the entry created doesn't need further modification
-        
-    def addGroup(self, group) :        
+
+    def addGroup(self, group) :
         """Adds a group to the quota storage, returns the old value if it already exists."""
         oldentry = self.getGroup(group.Name)
@@ -626,19 +637,19 @@
         return None # the entry created doesn't need further modification
 
-    def addUserToGroup(self, user, group) :    
+    def addUserToGroup(self, user, group) :
         """Adds an user to a group."""
         result = self.doSearch("SELECT COUNT(*) AS mexists FROM groupsmembers WHERE groupid=%s AND userid=%s" % (self.doQuote(group.ident), self.doQuote(user.ident)))
         try :
             mexists = int(result[0].get("mexists"))
-        except (IndexError, TypeError) :    
+        except (IndexError, TypeError) :
             mexists = 0
-        if not mexists :    
+        if not mexists :
             self.doModify("INSERT INTO groupsmembers (groupid, userid) VALUES (%s, %s)" % (self.doQuote(group.ident), self.doQuote(user.ident)))
-            
-    def delUserFromGroup(self, user, group) :    
+
+    def delUserFromGroup(self, user, group) :
         """Removes an user from a group."""
         self.doModify("DELETE FROM groupsmembers WHERE groupid=%s AND userid=%s" % \
                        (self.doQuote(group.ident), self.doQuote(user.ident)))
-            
+
     def addUserPQuota(self, upq) :
         """Initializes a user print quota on a printer."""
@@ -658,5 +669,5 @@
         upq.isDirty = False
         return None # the entry created doesn't need further modification
-        
+
     def addGroupPQuota(self, gpq) :
         """Initializes a group print quota on a printer."""
@@ -673,6 +684,6 @@
         gpq.isDirty = False
         return None # the entry created doesn't need further modification
-        
-    def savePrinter(self, printer) :    
+
+    def savePrinter(self, printer) :
         """Saves the printer to the database in a single operation."""
         self.doModify("UPDATE printers SET passthrough=%s, maxjobsize=%s, description=%s, priceperpage=%s, priceperjob=%s WHERE id=%s" \
@@ -683,6 +694,6 @@
                                  self.doQuote(printer.PricePerJob or 0.0), \
                                  self.doQuote(printer.ident)))
-                                 
-    def saveUser(self, user) :        
+
+    def saveUser(self, user) :
         """Saves the user to the database in a single operation."""
         self.doModify("UPDATE users SET limitby=%s, balance=%s, lifetimepaid=%s, email=%s, overcharge=%s, description=%s WHERE id=%s" \
@@ -694,6 +705,6 @@
                                   self.doQuote(self.userCharsetToDatabase(user.Description)), \
                                   self.doQuote(user.ident)))
-                                  
-    def saveGroup(self, group) :        
+
+    def saveGroup(self, group) :
         """Saves the group to the database in a single operation."""
         self.doModify("UPDATE groups SET limitby=%s, description=%s WHERE id=%s" \
@@ -701,18 +712,18 @@
                                   self.doQuote(self.userCharsetToDatabase(group.Description)), \
                                   self.doQuote(group.ident)))
-        
-    def writeUserPQuotaDateLimit(self, userpquota, datelimit) :    
+
+    def writeUserPQuotaDateLimit(self, userpquota, datelimit) :
         """Sets the date limit permanently for a user print quota."""
         self.doModify("UPDATE userpquota SET datelimit=%s WHERE id=%s" % (self.doQuote(datelimit), self.doQuote(userpquota.ident)))
-            
-    def writeGroupPQuotaDateLimit(self, grouppquota, datelimit) :    
+
+    def writeGroupPQuotaDateLimit(self, grouppquota, datelimit) :
         """Sets the date limit permanently for a group print quota."""
         self.doModify("UPDATE grouppquota SET datelimit=%s WHERE id=%s" % (self.doQuote(datelimit), self.doQuote(grouppquota.ident)))
-        
-    def increaseUserPQuotaPagesCounters(self, userpquota, nbpages) :    
+
+    def increaseUserPQuotaPagesCounters(self, userpquota, nbpages) :
         """Increase page counters for a user print quota."""
         self.doModify("UPDATE userpquota SET pagecounter=pagecounter + %s,lifepagecounter=lifepagecounter + %s WHERE id=%s" % (self.doQuote(nbpages), self.doQuote(nbpages), self.doQuote(userpquota.ident)))
-       
-    def saveBillingCode(self, bcode) :    
+
+    def saveBillingCode(self, bcode) :
         """Saves the billing code to the database."""
         self.doModify("UPDATE billingcodes SET balance=%s, pagecounter=%s, description=%s WHERE id=%s" \
